#pragma once

#include "../include/FWatchCore2Obj.hpp"

class __declspec(uuid("B07EFD66-C99B-445d-A507-6D12BD705269")) CEnumDir
	: public IEnumDir
	, public CComObjectRoot
	, public CComCoClass<CEnumDir>
	, private IErrorHandler /// pG[nh
{
public:
	DECLARE_OBJECT_DESCRIPTION("CEnumDir")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CEnumDir)
		COM_INTERFACE_ENTRY(IEnumDir)
	END_COM_MAP()

	/// PRIVATE

	HRESULT FinalConstruct() throw();

	HRESULT __stdcall HandleError(HRESULT v_errorCode) throw();

	/// IEnumDir

	HRESULT __stdcall BeginEnumeration(LPCWSTR v_pDirName, IEnumDirHandler* v_pCallback) throw();

private:

	HRESULT __stdcall BeginEnumeration0(LPCWSTR v_pDirName, IEnumDirHandler* v_pCallback, IErrorHandler* v_pErrorHandler) throw();

	CComPtr<IFindFileFactory> pFindFileFactory_;
};


class __declspec(uuid("4919D60B-F3DC-412a-BD63-33CA5B10C0B7")) CEnumDirFilterFactory
	: public IEnumDirFilterFactory
	, public CComObjectRoot
	, public CComCoClass<CEnumDirFilterFactory>
{
public:
	DECLARE_OBJECT_DESCRIPTION("CEnumDirFilterFactory")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CEnumDirFilterFactory)
		COM_INTERFACE_ENTRY(IEnumDirFilterFactory)
	END_COM_MAP()

	/// PRIVATE

	HRESULT FinalConstruct() throw();

	/// IEnumDirFilterFactory

	HRESULT __stdcall set_MaxLevel(UINT v_maxLevel) throw();

	HRESULT __stdcall get_MaxLevel(UINT* v_pMaxLevel) throw();

	HRESULT __stdcall set_NameFilter(INameMatcher* v_pNameMatcher) throw();

	HRESULT __stdcall get_NameFilter(INameMatcher** v_ppNameMatcher) throw();

	HRESULT __stdcall CreateFilter(IW32FindDataReceiver* v_pW32FindDataReceiver, IEnumDirHandler** v_ppCallback) throw ();

private:

	/**
	 * őċA[
	 */
	UINT maxLevel_;

	/**
	 * t@C̃tB^B
	 * w肳ĂȂ΁AׂāB
	 */
	CComPtr<INameMatcher> pNameMatcher_;

};

class __declspec(uuid("23B2B499-1688-497e-8CF7-20ACB4726A67")) CEnumDirFilter
	: public IEnumDirHandler
	, public IErrorHandler
	, public CComObjectRoot
	, public CComCoClass<CEnumDirFilter>
{
public:
	DECLARE_OBJECT_DESCRIPTION("CEnumDirFilter")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CEnumDirFilter)
		COM_INTERFACE_ENTRY(IEnumDirHandler)
		COM_INTERFACE_ENTRY(IErrorHandler)
	END_COM_MAP()

	HRESULT FinalConstruct() throw();

	HRESULT Init(INameMatcher* v_pNameMatcher, UINT v_maxLevel, IW32FindDataReceiver* v_pFindDataReceiver) throw();

	/// IEnumDirHandler

	HRESULT __stdcall OnInit() throw();

	HRESULT __stdcall OnExit(HRESULT v_exitCode) throw();

	HRESULT __stdcall BeginDirectory(LPCWSTR v_pFullPath) throw();

	HRESULT __stdcall EndDirectory(LPCWSTR v_pFullPath, HRESULT v_exitCode) throw();

	HRESULT __stdcall OnFindFile(LPCWSTR v_pFullPath, const WIN32_FIND_DATA* v_pFindData) throw();

	HRESULT __stdcall OnFindDirectory(LPCWSTR v_pFullPath, const WIN32_FIND_DATA* v_pFindData) throw();

	HRESULT __stdcall HandleError(HRESULT v_errorCode) throw();

private:

	HRESULT NotifyW32FindData(LPCWSTR v_pPath, const WIN32_FIND_DATA* v_pFindData) throw();

	/**
	 * ݂̐[
	 */
	UINT level_;

	/**
	 * őċA[
	 */
	UINT maxLevel_;

	/**
	 * t@C̃tB^B
	 * w肳ĂȂ΁AׂāB
	 */
	CComPtr<INameMatcher> pNameMatcher_;

	/**
	 * t@C̎󂯎
	 */
	CComPtr<IW32FindDataReceiver>  pFindDataReceiver_;
};
