#pragma once

#include "../include/FWatchCore2Obj.hpp"

class __declspec(uuid("C8C76D85-CFFE-4925-A014-0BD505BB5BD6")) CFindFile
	: public IFindFile2
	, public CComObjectRoot
	, public CComCoClass<CFindFile>
{
private:
	int maxLevel_;
	BOOL hasNext_;
	HANDLE hFindHandle_;
	WIN32_FIND_DATA findData_;
	DWORD errorCode_;

public:
	DECLARE_OBJECT_DESCRIPTION("CFindFile")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	CFindFile() throw();

	void FinalRelease() throw();

	HRESULT Begin(LPCWSTR v_dirName) throw();

	HRESULT __stdcall HasNext() throw();

	HRESULT __stdcall Next(WIN32_FIND_DATA* v_pFindData) throw();

	HRESULT __stdcall GetHandle(HANDLE* v_pHandle) throw();

	BEGIN_COM_MAP(CFindFile)
		COM_INTERFACE_ENTRY(IFindFile)
		COM_INTERFACE_ENTRY(IFindFile2)
	END_COM_MAP()
};

// __declspec(uuid("B86D8B40-9C79-40e3-8E05-DCDEDA14D2D4"))
class CFindFileFactory
	: public IFindFileFactory
	, public CComObjectRoot
	, public CComCoClass<CFindFileFactory>
{
public:
	DECLARE_OBJECT_DESCRIPTION("CFindFileFactory")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	HRESULT __stdcall Create(LPCWSTR v_dirName, IFindFile** v_ppEnumDir) throw();

	BEGIN_COM_MAP(CFindFileFactory)
		COM_INTERFACE_ENTRY(IFindFileFactory)
	END_COM_MAP()
};



