#pragma once

#include "../include/FWatchCore2Obj.hpp"

class __declspec(novtable, uuid("D5A478BF-6EAB-4bc9-BF5D-B6041E330DD7")) CFileInfoDiffAdaptor
	: public INamedFileInfoComparator
	, public CComObjectRoot
	, public CComCoClass<CFileInfoDiffAdaptor>
{
public:
	DECLARE_OBJECT_DESCRIPTION("CFileInfoDiffAdaptor")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CFileInfoDiffAdaptor)
		COM_INTERFACE_ENTRY(INamedFileInfoComparator)
	END_COM_MAP()

	/// INamedFileInfoComparator

	HRESULT __stdcall IsEquals(LPCWSTR v_pName, IFileInfo* v_pFileInfo1, IFileInfo* v_pFileInfo2) throw();

	/// PRIVATE 

	HRESULT Init(IFileInfoComparator* v_pFileInfoComparator,
		IFileInfoCollection* v_pFileInfoCollection1,
		IFileInfoCollection* v_pFileInfoCollection2) throw();

private:

	CComPtr<IFileInfoComparator> pFileInfoComparator_;

	CComPtr<IFileInfoCollection> pFileInfoCollection1_;

	CComPtr<IFileInfoCollection> pFileInfoCollection2_;
};
